| package |
package := Package name: 'US Treemap - Render Flat'.
package paxVersion: 0;
	basicComment: ''.

package basicPackageVersion: '0.014'.


package classNames
	add: #FlatRenderStrategy;
	yourself.

package methodNames
	add: #Rectangle -> #gdiTruncated;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'US Treemap - Render Abstract';
	yourself).

package!

"Class Definitions"!

AbstractTreeMapRenderStrategy subclass: #FlatRenderStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Rectangle methodsFor!

gdiTruncated
	"Answer a new <Rectangle> whose origin and corner coordinates
	are truncated to the nearest integer."

	^self species origin: origin truncated  corner: corner ceiling ! !
!Rectangle categoriesFor: #gdiTruncated!converting!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

FlatRenderStrategy guid: (GUID fromString: '{4AE50A5A-EC61-4055-AABE-EFA41B54F964}')!
FlatRenderStrategy comment: ''!
!FlatRenderStrategy categoriesForClass!Treemap-Render! !
!FlatRenderStrategy methodsFor!

render: node using: renderState 
	#USTodo.	"Make the border color changable"
	canvas
		selectClipRegion: (Region rectangle: node layoutRectangle truncated);
brush: (Brush color: (renderer nodeColor: node object));
pen: (Pen color: Color black);

		rectangle: node layoutRectangle gdiTruncated! !
!FlatRenderStrategy categoriesFor: #render:using:!public! !

!FlatRenderStrategy class methodsFor!

description 
^'Flat'! !
!FlatRenderStrategy class categoriesFor: #description!public! !

"Binary Globals"!

"Resources"!

