| package |
package := Package name: 'US Tooltips'.
package paxVersion: 0;
	basicComment: 'toolTip := Tooltip new.
toolTipHandle := toolTip asParameter.

view := PushButton show.

toolInfo := TOOLINFO new.
toolInfo uFlags: TTF_IDISHWND | TTF_SUBCLASS.
toolInfo uFlags: 1 | 16.
toolInfo uId: view handle.

myTooltip := ''This is the tip''.
toolInfo text: myTooltip. 

answer := UserLibrary default
sendMessage: toolTipHandle
msg: 1028 "TTM_ADDTOOL"
wParam: 0
lParam: toolInfo yourAddress

Win32Constants
	at: ''TTN_FIRST'' put: -520;
	at: ''TTN_LAST'' put: -549;
	at: ''WM_USER'' put: 1024;
	at: ''TTM_ACTIVATE'' put: 1025;
	at: ''TTM_ADDTOOLW'' put: 1074;
	at: ''TTM_DELTOOLW'' put: 1075;
	at: ''TTM_ENUMTOOLSW'' put: 1082;
	at: ''TTM_GETCURRENTTOOLW'' put: 1083;
	at: ''TTM_GETTEXTW'' put: 1080;
	at: ''TTM_GETTOOLINFOW'' put: 1077;
	at: ''TTM_HITTESTW'' put: 1079;
	at: ''TTM_NEWTOOLRECTW'' put: 1076;
	at: ''TTM_SETTOOLINFOW'' put: 1078;
	at: ''TTM_UPDATETIPTEXTW'' put: 1081;
	at: ''TTM_ADDTOOLA'' put: 1028;
	at: ''TTM_DELTOOLA'' put: 1029;
	at: ''TTM_ENUMTOOLSA'' put: 1038;
	at: ''TTM_GETCURRENTTOOLA'' put: 1039;
	at: ''TTM_GETTEXTA'' put: 1035;
	at: ''TTM_GETTOOLINFOA'' put: 1032;
	at: ''TTM_HITTESTA'' put: 1034;
	at: ''TTM_NEWTOOLRECTA'' put: 1030;
	at: ''TTM_SETTOOLINFOA'' put: 1033;
	at: ''TTM_UPDATETIPTEXTA'' put: 1036;
	at: ''TTM_GETTOOLCOUNT'' put: 1037;
	at: ''TTM_RELAYEVENT'' put: 1031;
	at: ''TTM_SETDELAYTIME'' put: 1027;
	at: ''TTM_WINDOWFROMPOINT'' put: 1040;
	at: '' TTM_POP'' put: WM_USER + 28;
	at: ''TTM_SETMARGIN'' put: WM_USER + 26;
	at: ''TTM_GETMARGIN'' put: WM_USER + 27;
	at: ''TTM_GETMAXTIPWIDTH'' put: WM_USER + 25;
	at: ''TTM_SETMAXTIPWIDTH'' put: WM_USER + 24;
	at: ''TTM_TRACKACTIVATE'' put: WM_USER + 17;
	at: ''TTM_TRACKPOSITION'' put: WM_USER + 18;
	at: ''TTM_SETTIPBKCOLOR'' put: WM_USER + 19;
	at: ''TTM_SETTIPTEXTCOLOR'' put: WM_USER + 20;
	at: ''TTM_GETDELAYTIME'' put: WM_USER + 21;
	at: ''TTM_GETTIPBKCOLOR'' put: WM_USER + 22;
	at: ''TTM_GETTIPTEXTCOLOR'' put: WM_USER + 23;
	at: ''TTN_GETDISPINFOA'' put: TTN_FIRST - 0;
	at: ''TTN_GETDISPINFOW'' put: TTN_FIRST - 10;
	at: ''TTN_SHOW'' put: TTN_FIRST - 1;
	at: ''TTN_POP'' put: TTN_FIRST - 2;
	at: ''TTN_NEEDTEXTW'' put: -530;
	at: ''TTN_NEEDTEXTA'' put: -520

'.

package basicPackageVersion: '0.004'.

package basicScriptAt: #preinstall put: 'Win32Constants
	at: ''TTN_FIRST'' put: -520;
	at: ''TTN_LAST'' put: -549;
	at: ''TTM_ACTIVATE'' put: 1025;
	at: ''TTM_ADDTOOL'' put: 1028;
	at: ''TTM_DELTOOL'' put: 1029;
	at: ''TTM_ENUMTOOLS'' put: 1038;
	at: ''TTM_GETCURRENTTOOL'' put: 1039;
	at: ''TTM_GETTEXT'' put: 1035;
	at: ''TTM_GETTOOLINFO'' put: 1032;
	at: ''TTM_HITTEST'' put: 1034;
	at: ''TTM_NEWTOOLRECT'' put: 1030;
	at: ''TTM_SETTOOLINFOA'' put: 1033;
	at: ''TTM_UPDATETIPTEXT'' put: 1036;
	at: ''TTM_GETTOOLCOUNT'' put: 1037;
	at: ''TTM_RELAYEVENT'' put: 1031;
	at: ''TTM_SETDELAYTIME'' put: 1027;
	at: ''TTM_WINDOWFROMPOINT'' put: 1040;
	at: '' TTM_POP'' put: 1024 + 28;
	at: ''TTM_SETMARGIN'' put: 1024 + 26;
	at: ''TTM_GETMARGIN'' put: 1024 + 27;
	at: ''TTM_GETMAXTIPWIDTH'' put: 1024 + 25;
	at: ''TTM_SETMAXTIPWIDTH'' put: 1024 + 24;
	at: ''TTM_TRACKACTIVATE'' put: 1024 + 17;
	at: ''TTM_TRACKPOSITION'' put: 1024 + 18;
	at: ''TTM_SETTIPBKCOLOR'' put: 1024 + 19;
	at: ''TTM_SETTIPTEXTCOLOR'' put: 1024 + 20;
	at: ''TTM_GETDELAYTIME'' put: 1024 + 21;
	at: ''TTM_GETTIPBKCOLOR'' put: 1024 + 22;
	at: ''TTM_GETTIPTEXTCOLOR'' put: 1024 + 23;
	at: ''TTN_GETDISPINFO'' put: -520 - 0;
	at: ''TTN_SHOW'' put: -520 - 1;
	at: ''TTN_POP'' put: -520 - 2;
	at: ''TTN_NEEDTEXT'' put: -520;
	at: ''TTS_ALWAYSTIP'' put: 1;
	at: ''TTS_NOPREFIX'' put: 2;
	at: ''TTS_NOANIMATE'' put: 16r10;
	at: ''TTS_NOFADE'' put: 16r20;
	at: ''TTS_BALLOON'' put: 16r40;
	at: ''TTS_CLOSE'' put: 16r80;
	at: ''TTF_IDISHWND'' put: 1;
	at: ''TTF_CENTERTIP'' put: 2;
	at: ''TTF_RTLREADING'' put: 4;
	at: ''TTF_SUBCLASS'' put: 16;
	at: ''TTDT_AUTOMATIC'' put: 0;
	at: ''TTDT_AUTOPOP'' put: 2;
	at: ''TTDT_INITIAL'' put: 3;
	at: ''TTDT_RESHOW'' put: 1;
	at: ''TTM_SETTITLE'' put: 1024 + 32;
	at: ''TTM_UPDATE'' put: 1024 + 12;
	at: ''TTM_POP'' put: 1024 + 28;
	at: ''TTM_POPUP'' put: 1024 + 34!!'.

package classNames
	add: #Tooltip;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	yourself).

package!

"Class Definitions"!

ControlView subclass: #Tooltip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

Tooltip guid: (GUID fromString: '{63A5EB2F-47B0-4169-855C-54301CDC69A3}')!
Tooltip comment: ''!
!Tooltip categoriesForClass!Unclassified! !
!Tooltip methodsFor!

activateControl: aBoolean 
	
	^UserLibrary default 
		sendMessage: self handle
		msg: TTM_ACTIVATE
		wParam: aBoolean asDword
		lParam: 0!

addTool: aView 
	| toolInfo |
	(toolInfo := TOOLINFO new)
		uFlags: TTF_IDISHWND | TTF_SUBCLASS;
		hwnd: aView handle;
		uId: aView handle;
		textCallback.
	UserLibrary default 
		sendMessage: self handle
		msg: TTM_ADDTOOL
		wParam: 0
		lParam: toolInfo yourAddress!

autopopDelayTime
^self delayTime: TTDT_AUTOPOP!

basicCreateAt: position extent: extentPoint 
|hWnd|
	hWnd:= super basicCreateAt: position extent: extentPoint.
	UserLibrary default 
		setWindowPos: self asParameter
		hWndInsertAfter: HWND_TOPMOST
		x: 0
		y: 0
		cx: 0
		cy: 0
		uFlags: SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE.
^hWnd!

defaultWindowStyle
	"Private - Answer the default basic window creation style"

	^##(WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP | TTS_BALLOON)	!

delayTime: dwDuration 
^self sendMessage: TTM_GETDELAYTIME
		wParam: dwDuration
		lParam: 0!

initialDelayTime
	^self delayTime: TTDT_INITIAL!

pop
	^UserLibrary default 
		sendMessage: self handle
		msg: TTM_POP
		wParam: 0
		lParam: 0!

reshowDelayTime
	^self delayTime: TTDT_RESHOW! !
!Tooltip categoriesFor: #activateControl:!constants!private! !
!Tooltip categoriesFor: #addTool:!constants!private! !
!Tooltip categoriesFor: #autopopDelayTime!constants!private! !
!Tooltip categoriesFor: #basicCreateAt:extent:!private!realizing/unrealizing! !
!Tooltip categoriesFor: #defaultWindowStyle!constants!private! !
!Tooltip categoriesFor: #delayTime:!constants!private! !
!Tooltip categoriesFor: #initialDelayTime!constants!private! !
!Tooltip categoriesFor: #pop!constants!private! !
!Tooltip categoriesFor: #reshowDelayTime!constants!private! !

!Tooltip class methodsFor!

winClassName
	"Private - Answer the name of the Windows window class to use when realizing the receiver."

	^'tooltips_class32'! !
!Tooltip class categoriesFor: #winClassName!constants!private! !

"Binary Globals"!

"Resources"!

